package
{
	import flash.display.Bitmap;
	import flash.media.Sound;
	import flash.utils.ByteArray;
	import flash.utils.Dictionary;
	
	import starling.text.BitmapFont;
	import starling.text.TextField;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class Assets
	{
		[Embed(source = "../assets/textures/bg_level_960_640.png")]
		private static const Background:Class;

		[Embed(source="../assets/textures/textureAtlas.xml", mimeType="application/octet-stream")]
		private static const TextureAtlasXml:Class;
		
		[Embed(source="../assets/textures/textureAtlas.png")]
		private static const TextureAtlasTexture:Class;
		
		private static var sTextures:Dictionary = new Dictionary();
		private static var sTextureAtlas:TextureAtlas;
		
		public static function getTexture(name:String):Texture
		{
			if (sTextures[name] == undefined)
			{
				var data:Object = new Assets[name]();
				
				if (data is Bitmap)
					sTextures[name] = Texture.fromBitmap(data as Bitmap);
				else if (data is ByteArray)
					sTextures[name] = Texture.fromAtfData(data as ByteArray);
			}
			
			return sTextures[name];
		}
				
		public static function getTextureAtlas():TextureAtlas
		{
			if (sTextureAtlas == null)
			{
				var texture:Texture = getTexture("TextureAtlasTexture");
				var xml:XML = XML(new TextureAtlasXml());
				sTextureAtlas = new TextureAtlas(texture, xml);
			}
			
			return sTextureAtlas;
		}		
	}
}